#include "movement.h"

// ================================================================
// odnajduje ruch w buforze na podstawie timestampu
// ================================================================
struct ruch extract_move(int timestamp, struct ruch *buf, int ilep, int co)
{
	int i;
	struct ruch ept = {-4, -1, -1};
	struct ruch lst = {-2, -1, -1};
	
	for (i=0; i<ilep; i++)
	{
		// znajdz pasujacy timestamp
		if (buf[i].ts == timestamp)
		{
			if (co == G) glag = 0;	// wylacz sygnalizacje laga
			else if (co == P) plag = 0;
			return buf[i];
		}
		// ewentualnie znajdz ostatni pasujacy timestamp
		else if (buf[i].ts < timestamp)
		{
		 	lst = buf[i];
		}
		// jesli ts sa wieksze to przerwij
		else if (buf[i].ts > timestamp)
		{
			break;
		}
	}
	
	// sytuacja 1) jest starszy TS i nowszy TS
	if ((i>0) && (i<ilep))
	{
		lst.ts = TS_INTERPOLATE;	// zwykla interpolacja
		if (co == G) glag = 0;	// wylacz sygnalizacje laga
		else if (co == P) plag = 0;
		return lst;
	}
	// sytuacja 2) jest starszy TS, nie ma nowszego
	else if ((i>0) && (i==ilep))
	{
		lst.ts = TS_LAG;	// lag
		if (co == G) glag = 1;	// sygnalizuj lag
		else if (co == P) plag = 1;
		return lst;
	}
	// sytuacja 3) jest nowszy, ale nie ma starszego
	else if (i==0)
	{
		lst.ts = TS_WAIT;	// oczekiwanie na waznosc obecnych danych
		if (co == G) glag = 0;	// sygnalizuj lag
		else if (co == P) plag = 0;
		return lst;
	}
	
	else return ept;
	
}

// ================================================================
// sprobuj poruszyc w danym kierunku graczem
// ================================================================
void trymove(int dw, int dk)
{	
	int kind;
	int nokey = 0;
	
	if (!started) return;	// zablokuj ruchy jesli gra sie nie zaczela
	
	if ((dw == 0) && (dk == 0))	// poruszaj sie w ostatnio znanym kierunku
	{	
		dk = dir_k;
		dw = dir_w;
		nokey = 1;
	}
	
	// rozpoznaj kierunek
	if (dw == -1) kind = MV_UP;
	else if (dw == 1) kind = MV_DOWN;
	else if (dk == -1) kind = MV_LEFT;
	else if (dk == 1) kind = MV_RIGHT;	
	
	// sprawdz, czy w danym kierunku nie ma sciany
	switch(kind)
	{
		case MV_UP:
			if (player_pos.w > 0)
			{
				if (buf[player_pos.w-1][player_pos.k] != ' ') 
				{
					if (nokey) { dir_k=0; dir_w=0; }
					return;
				}
			}
			else
			{
				if (nokey) { dir_k=0; dir_w=0; }
				return;
			}
			break;
		
		case MV_DOWN:
			if (player_pos.w < wiersze)
			{
				if (buf[player_pos.w+1][player_pos.k] != ' ')
				{
					if (nokey) { dir_k=0; dir_w=0; }
					return;
				}
			}
			else
			{
				if (nokey) { dir_k=0; dir_w=0; }
				return;
			}
			break;
		
		case MV_LEFT:
			if (player_pos.k > 0)
			{
				if (buf[player_pos.w][player_pos.k-1] != ' ')
				{
					if (nokey) { dir_k=0; dir_w=0; }
					return;
				} 
			}
			else
			{
				if (nokey) { dir_k=0; dir_w=0; }
				return;
			}
			break;
		
		case MV_RIGHT:
			if (player_pos.k < kolumny)
			{
				if (buf[player_pos.w][player_pos.k+1] != ' ')
				{
					if (nokey) { dir_k=0; dir_w=0; }
					return;
				}
			}
			else
			{
				if (nokey) { dir_k=0; dir_w=0; }
				return;
			}
			break;
		default: return;
	}
	
	// przypisz nowe pozycje graczowi
	player_pos.w += dw;
	player_pos.k += dk;
	
	// sprawdz, czy nie zlapalismy golebia
	if (!glag && (last_pigeon_position.w == player_pos.w) && (last_pigeon_position.k == player_pos.k))
	{
		zlapany.w = player_pos.w;
		zlapany.k = player_pos.k;
		zlapany.ts = timestamp;
		
		pigeon_issued = 1;
	}
	
	// przesuniecie gracza nie bylo skutkiem nacisniecia klawisza
	if (!nokey)
	{
		dir_w = dw;
		dir_k = dk;
	}
	
	return;
}

// ================================================================
// przewidywanie ruchu przeciwnika
// ================================================================
#define GR gracze[opp]
void predict(int opp)
{
	// wyjdz jesli za malo danych do predykcji
	if (GR.ile_pred < 2) return;
	
	// trend i predkosc ruchu
	int i;
	float inv_speed, cumul = 0;
	
	// ponizsze instukcje zostaly zakomentowane w zwiazku z trudnosciami
	// w ustawieniu ich optymalnych parametrow
	
	/*
	int poziomo = 0, pionowo = 0;
	int interval, poczw, poczk, way;
	
	// znajdz trend i predkosc
	for (i=0; i<GR.ile_pred; i++)
	{
		if (i==0)
		{
			poczw=GR.buf_pred[i].w;
			poczk=GR.buf_pred[i].k;
		}
		else
		{
			if (GR.buf_pred[i].k > poczk) poziomo++;
			else if (GR.buf_pred[i].k < poczk) poziomo--;
			
			if (GR.buf_pred[i].w > poczw) pionowo++;
			else if (GR.buf_pred[i].w < poczw) pionowo--;
			
			poczw = GR.buf_pred[i].w;
			poczk = GR.buf_pred[i].k;			
		}
	}
	
	way = abs(poziomo) + abs(pionowo);
	interval = GR.buf_pred[GR.ile_pred-1].ts - GR.buf_pred[0].ts;
	if (interval == 0.0) interval = 1.0;
	
	inv_speed = (float) interval / (float) way;
	
	inv_speed *= 0.5;
	if (inv_speed < 0.5) inv_speed = 0.5;
	if (inv_speed > 3.0) inv_speed = 3.0;
	inv_speed = 0.1;*/
	
	inv_speed = 1;
	
	GR.buf_moves[0] = GR.buf_pred[GR.ile_pred-1];
	int czas = GR.buf_moves[0].ts;
	
	// okresl kierunek w ktorym sie poruszamy
	int pz, pn, dir;
	pz = GR.buf_pred[GR.ile_pred-1].k - GR.buf_pred[GR.ile_pred-2].k;
	pn = GR.buf_pred[GR.ile_pred-1].w - GR.buf_pred[GR.ile_pred-2].w;
	

	if (abs(pz) > abs(pn))
	{
		if (pz < 0) dir = MV_LEFT;
		else dir = MV_RIGHT;
	}
	else
	{
		if (pn < 0) dir = MV_UP;
		else dir = MV_DOWN;
	}
	
	czas = timestamp;
	
	// zapelniamy tablice przewidzianych ruchow przeciwnika
	for (i=1; i<MAX_OPP_MOVES; i++)
	{
		czas+=2;
		cumul += inv_speed;
		GR.buf_moves[i] = GR.buf_moves[i-1];
		GR.buf_moves[i].ts = czas;
		int a, b, jmp;
		
		if (dir == MV_LEFT)
		{
			jmp = (int)floor(cumul);
			b = GR.buf_moves[0].k-jmp;
			a = GR.buf_moves[i].w;
			if ((a >= 0) && (b >= 0) && (a < MAX_LEVEL_HEIGHT) && (b < MAX_LEVEL_WIDTH) && (buf[a][b] == ' ')) 
				GR.buf_moves[i].k = b;
			else dir = MV_STOP;
		}
		else if (dir == MV_RIGHT)
		{
			jmp = (int)floor(cumul);
			b = GR.buf_moves[0].k+jmp;
			a = GR.buf_moves[i].w;
			if ((a >= 0) && (b >= 0) && (a < MAX_LEVEL_HEIGHT) && (b < MAX_LEVEL_WIDTH) && (buf[a][b] == ' ')) 
				GR.buf_moves[i].k = b;
			else dir = MV_STOP;
		}
		else if (dir == MV_UP)
		{
			jmp = (int)floor(cumul);
			a = GR.buf_moves[0].w-jmp;
			b = GR.buf_moves[i].k;
			if ((a >= 0) && (b >= 0) && (a < MAX_LEVEL_HEIGHT) && (b < MAX_LEVEL_WIDTH) && (buf[a][b] == ' ')) 
				GR.buf_moves[i].w = a;
			else dir = MV_STOP;
		}
		else if (dir == MV_DOWN)
		{
			jmp = (int)floor(cumul);
			a = GR.buf_moves[0].w+jmp;
			b = GR.buf_moves[i].k;
			if ((a >= 0) && (b >= 0) && (a < MAX_LEVEL_HEIGHT) && (b < MAX_LEVEL_WIDTH) && (buf[a][b] == ' ')) 
				GR.buf_moves[i].w = a;
			else dir = MV_STOP;
		}
	}

	GR.buf_count = MAX_OPP_MOVES;
}
