#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include <unistd.h>
#include "defs.h"
#include "siec.h"
#include <string.h>

int generate_pigeon = 0; // ustawione oznacza, ze trzeba wygenerowac nowe ruchy golebia

struct position player_pos[PLAYERS_MAX][MOVES_TO_REMEMBER]; // polozenie i ostatnie ruchy graczy
int top_pos[PLAYERS_MAX] = {0}; // numer w tablicy player_pos okreslajacy ostatnie polozenie
short int scores[PLAYERS_MAX] = {0}; // punkty graczy

struct position pigeon_moves[2*MAX_PIGEON_MOVES] = {{1, 1, 0}};
int last_pos = 0;

int koniec = 0;
int timestamp = 0;

char plansza[MAX_LEVEL_HEIGHT][MAX_LEVEL_WIDTH];
int wiersze, kolumny;


void random_place(short int *wiersz, short int *kolumna)
{
	do
	{
		*wiersz = (short int) (rand() % wiersze);
		*kolumna = (short int) (rand() % kolumny);
	}
	while(plansza[*wiersz][*kolumna] != ' ');
}



void* count(void* data)
{	
	while(!koniec)
	{
		usleep(100000);
		timestamp++;
		if(timestamp + 10 > pigeon_moves[last_pos].timestamp)
		{	
			generate_pigeon = 1;
		}
	}
	
	return NULL;
}


int main(int argc, char *argv[])
{
	int i, j, port = PORT;
	TConnection polaczenie;
	pthread_t thread_timer;

	FILE* pl;
	if(argc >= 3)
		pl = fopen(argv[2], "r");
	else
		pl = fopen("level.txt", "r");

	if(pl == NULL) 
	{
		perror("Blad otwarcia pliku pliku planszy!\n");
		return -1;
	}
	
	for(i = 0; fgets(plansza[i], MAX_LEVEL_WIDTH, pl); i++);
	
	kolumny = strlen(plansza[0])-2;
	wiersze = i-1;


	if(argc > 1) port = atoi(argv[1]);
	if(port <= 1024)
	{
		printf("Numer portu serwera powinien byc liczba wieksza niz 1024.\n");
		port = PORT;
	}

	for(i = 0; i < PLAYERS_MAX; i++)
		for(j = 0; j < MOVES_TO_REMEMBER; j++)	
		{
			player_pos[i][j].timestamp = 0;
			player_pos[i][j].x = -1;
			player_pos[i][j].y = -1;
		}

	random_place(&(pigeon_moves[last_pos].y), &(pigeon_moves[last_pos].x)); // poczatkowe polozenie golebia
	pigeon_moves[last_pos].timestamp = timestamp;

	if(polaczenie.create(port) == 0)
		printf("Serwer uruchomiony na porcie %d.\n", port);
	else // pojawil sie blad
	{
		printf("Blad przy uruchamianiu serwera!\n");
		return 1;
	}

	
	pthread_create(&thread_timer, NULL, count, NULL); // watek timera

	// glowna petla serwera
	do
	{
		polaczenie.get_something();
	}
	while(1);

	pthread_join(thread_timer, NULL);
	
	return 0;
}

